<?

/*

	Utility functions.

        (C) Copyright 2005 by Mogens Kjaer, mk@lemo.dk

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful, 
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License 
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

function level_text($level)
{
  switch($level)
  {
  case 0:
    return "Meget nem";
    break;
  case 1:
    return "Nem";
    break;
  case 2:
    return "Medium";
    break;
  case 3:
    return "Svr";
    break;
  case 4:
    return "Meget svr";
    break;
  }
}

function symmetrical_text($symmetrical)
{
  switch($symmetrical)
  {
  case 0:
    return "Ingen";
    break;
  case 1:
    return "X og y spejling";
    break;
  case 2:
    return "180".chr(176)." rotation";
    break;
  }
}

function sudoku_db()
{
  mysql_pconnect("localhost","sudoku","sudoku");
  mysql_select_db("sudoku");
}

function find_possibilities($nx, $ny, $row, $col, $problem, &$possibilities)
{
  global $SYMBOLLIST;
  /* find possibilities for cell ($row,$col), and
     return them in the array $possibilities */

  $possibilities = array();

  $nxny = $nx*$ny;

  /* Start with everything is possible */

  for($i=1; $i<=$nxny; $i++) $possibilities[$i] = 1;

  /* Remove from row */
  for($i=0; $i<$nxny; $i++)
  {
    $c = strpos($SYMBOLLIST, substr($problem, $row*$nxny+$i, 1));
    if($c>0) $possibilities[$c]=0;
  }

  /* Remove from col */
  for($j=0; $j<$nxny; $j++)
  {
    $c = strpos($SYMBOLLIST, substr($problem, $j*$nxny+$col, 1));
    if($c>0) $possibilities[$c]=0;
  }

  /* Remove from subcell */
  for($i=0; $i<$nx; $i++)
  for($j=0; $j<$ny; $j++)
  {
    $c = strpos($SYMBOLLIST, substr($problem, (floor($row/$nx)*$nx+$i)*$nxny+floor($col/$ny)*$ny+$j, 1));
    if($c>0) $possibilities[$c]=0;
  }
}

$SYMBOLLIST = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
?>
